from ..base import BaseExporter
from pathlib import Path

POSTFIX_QUEUES = ["active", "bounce", "deferred", "incoming", "maildrop"]

class CustomExporter(BaseExporter):
    def metric_config(self):
        return {
            "postfix_queue_size": {"type": "Gauge", "labels": ["queue"]},
        }

    def generate(self):
        postfix_queue_size = self.metrics.get('postfix_queue_size')
        for queue in POSTFIX_QUEUES:
            path = Path("%s/%s" % ("/var/spool/postfix/", queue))
            count = len([f for f in path.rglob("*") if f.is_file()])
            postfix_queue_size.labels(queue).set(count)
